############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus.xio import XioSocket
from pyGlobus.xio import XioSocketException
import time
from threading import Thread
import unittest
from pyGlobus.util import Buffer

class TestClientRead(Thread):
    def run(self):
        sock = XioSocket()
        sock.settimeout(3)
        sock.connect("localhost", 6768)
        buf = Buffer(1024 * 64)
        try:

            sock.read(buf)
            pass
        except XioSocketException, ex:
            print ex
            print "TEST PASSED"
        else:
            print "TEST FAILED"
        sock.close()

        
class TimeoutTestCases(unittest.TestCase):

    def checkAcceptTimeout(self):
        print "testing accept timeouts"
        try:
            sock = XioSocket()
            sock.settimeout(3)
            port = sock.create_listener(port=6768)
            newSock = sock.accept()
        except XioSocketException, ex:
            print ex
            print "TEST PASSED"
        else:
            print "TEST FAILED"

        sock.close()

    def checkReadTimeout(self):
        print "testing read timeouts"
        sock = XioSocket()
        port = sock.create_listener(port=6768) 
        client = TestClientRead()
        client.start()
        client.join()
        newSock = sock.accept()
        newSock.close()
        sock.close()


        
def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TimeoutTestCases, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
